Bug 208294 - [exp-run] Add CONFIGURE_OUTSOURCE support
Summary: [exp-run] Add CONFIGURE_OUTSOURCE support
Status: Closed FIXED
Alias: None
Product: Ports & Packages
Classification: Unclassified
Component: Ports Framework (show other bugs)
Version: Latest
Hardware: Any Any
: --- Affects Only Me
Assignee: Jan Beich
URL: https://reviews.freebsd.org/D4157
Keywords: feature, patch
Depends on:
Blocks: 208309
  Show dependency treegraph
 
Reported: 2016-03-25 19:12 UTC by Jan Beich
Modified: 2016-04-13 10:44 UTC (History)
2 users (show)

See Also:


Attachments
review D4157 + review D4158 + review D4169 (18.87 KB, application/x-octet-stream)
2016-03-25 19:12 UTC, Jan Beich
no flags Details
review D4157 + review D4158 + review D4169, v1 (18.62 KB, patch)
2016-03-25 21:30 UTC, Jan Beich
no flags Details | Diff
v1.1: review D4157 + review D4158 + review D4169 (18.25 KB, patch)
2016-03-26 17:09 UTC, Jan Beich
no flags Details | Diff
v1.2: review D4157 + review D4158 + review D4169 (33.62 KB, patch)
2016-03-26 21:15 UTC, Jan Beich
no flags Details | Diff
v1.3: review D4157 + review D4158 + review D4169 (34.23 KB, patch)
2016-03-26 21:39 UTC, Jan Beich
no flags Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Jan Beich freebsd_committer 2016-03-25 19:12:18 UTC
Created attachment 168627 [details]
review D4157 + review D4158 + review D4169

Tracking only exp-run here. Combined patch attached.
Comment 1 Jan Beich freebsd_committer 2016-03-25 21:30:37 UTC
Created attachment 168631 [details]
review D4157 + review D4158 + review D4169, v1

A few typos fixed that shouldn't affect build.
Comment 2 Jan Beich freebsd_committer 2016-03-26 17:09:24 UTC
Created attachment 168656 [details]
v1.1: review D4157 + review D4158 + review D4169

Better examples but shouldn't affect overall picture of the exp-run from previous version.
Comment 3 Gerald Pfeifer freebsd_committer 2016-03-26 18:49:28 UTC
For GCC, a logical user of this https://gcc.gnu.org/install/configure.html
states:

  "building where objdir is a subdirectory of srcdir is unsupported".

The documentation in the patch has builddir below the source directory,
hower:

+    $ mkdir build
+    $ cd build
+    $ ../configure
Comment 4 Jan Beich freebsd_committer 2016-03-26 19:47:06 UTC
It's actually under ${WRKDIR}/.build like USES=cmake:outsource.

  # after bug 208309
  $ make -V CONFIGURE_WRKSRC
  /usr/ports/lang/gcc/work/.build
  $ make -V WRKSRC
  /usr/ports/lang/gcc/work/gcc-4.8.5

Thanks for feedback. To avoid confusion I'll replace the illustration in CHANGES with

    $ mkdir ../.build
    $ cd ../.build
    $ ${OLDPWD}/configure
    $ gmake
    $ gmake install

and convert/include lang/gcc* patches here for exp-run.
Comment 5 Jan Beich freebsd_committer 2016-03-26 21:15:30 UTC
Created attachment 168658 [details]
v1.2: review D4157 + review D4158 + review D4169

More examples: lang/gcc* and a few forks.
Comment 6 Jan Beich freebsd_committer 2016-03-26 21:39:13 UTC
Created attachment 168661 [details]
v1.3: review D4157 + review D4158 + review D4169

Minor cleanup in examples: lang/gcc* and devel/psptoolchain-gcc-stage1.
Comment 7 Antoine Brodin freebsd_committer 2016-04-01 20:41:08 UTC
Exp-run looks fine
Comment 8 commit-hook freebsd_committer 2016-04-13 10:37:18 UTC
A commit references this bug:

Author: jbeich
Date: Wed Apr 13 10:36:18 UTC 2016
New revision: 413184
URL: https://svnweb.freebsd.org/changeset/ports/413184

Log:
  Consistently prefer ${CONFIGURE_CMD} over ./${CONFIGURE_SCRIPT}

  This also fixes SET_LATE_CONFIGURE_ARGS with custom CONFIGURE_CMD.

  PR:		208294
  Exp-run by:	antoine
  Approved by:	portmgr (antoine), perl (mat)
  Differential Revision:	https://reviews.freebsd.org/D4158

Changes:
  head/Mk/Uses/perl5.mk
  head/Mk/bsd.port.mk
  head/databases/p5-Class-DBI-Plugin-Senna/Makefile
  head/devel/fb-adb/Makefile
  head/devel/qmake5/Makefile
  head/games/eboard/Makefile
  head/games/nimuh/Makefile
  head/games/volleyball/Makefile
  head/irc/inspircd/Makefile
  head/lang/ghc/Makefile
  head/textproc/groff/Makefile
  head/textproc/p5-XML-DifferenceMarkup/Makefile
  head/www/interchange/Makefile
  head/www/nginx/Makefile
  head/www/nginx-devel/Makefile
  head/www/p5-RT-Authen-ExternalAuth/Makefile
  head/www/p5-RT-Extension-LDAPImport/Makefile
  head/www/p5-RT-Extension-MandatoryOnTransition/Makefile
  head/www/p5-RT-Extension-SLA/Makefile
  head/www/p5-RTx-Calendar/Makefile
  head/www/tengine/Makefile
  head/x11-toolkits/tix/Makefile
Comment 9 commit-hook freebsd_committer 2016-04-13 10:37:19 UTC
A commit references this bug:

Author: jbeich
Date: Wed Apr 13 10:36:55 UTC 2016
New revision: 413185
URL: https://svnweb.freebsd.org/changeset/ports/413185

Log:
  Change default directory used by USES=autoreconf to WRKSRC

  PR:		208294
  Exp-run by:	antoine
  Reviewed by:	tijl
  Approved by:	portmgr (mat via D4157)
  Differential Revision:	https://reviews.freebsd.org/D4169

Changes:
  head/Mk/Uses/autoreconf.mk
  head/graphics/p5-ming/Makefile
  head/graphics/py-ming/Makefile
Comment 10 commit-hook freebsd_committer 2016-04-13 10:38:21 UTC
A commit references this bug:

Author: jbeich
Date: Wed Apr 13 10:37:34 UTC 2016
New revision: 413186
URL: https://svnweb.freebsd.org/changeset/ports/413186

Log:
  Add CONFIGURE_OUTSOURCE support

  If CONFIGURE_OUTSOURCE is defined HAS_CONFIGURE invokes configure script
  and builds the port out of source tree, under ${WRKDIR}/.build by default.
  The feature is inspired by USES=cmake:outsource and USES=qmake:outsource.

  PR:		208294
  Exp-run by:	antoine
  Approved by:	portmgr (mat)
  Differential Revision:	https://reviews.freebsd.org/D4157

Changes:
  head/CHANGES
  head/Mk/bsd.port.mk
Comment 11 commit-hook freebsd_committer 2016-04-13 10:41:24 UTC
A commit references this bug:

Author: jbeich
Date: Wed Apr 13 10:40:59 UTC 2016
New revision: 413188
URL: https://svnweb.freebsd.org/changeset/ports/413188

Log:
  lang/gcc*: convert to CONFIGURE_OUTSOURCE

  PR:		208294, 208309
  Exp-run by:	antoine
  Approved by:	gerald (maintainer)
  Differential Revision:	https://reviews.freebsd.org/D4157

Changes:
  head/lang/gcc/Makefile
  head/lang/gcc46/Makefile
  head/lang/gcc47/Makefile
  head/lang/gcc48/Makefile
  head/lang/gcc49/Makefile
  head/lang/gcc5/Makefile
  head/lang/gcc5-devel/Makefile
  head/lang/gcc6-devel/Makefile
Comment 12 commit-hook freebsd_committer 2016-04-13 10:42:27 UTC
A commit references this bug:

Author: jbeich
Date: Wed Apr 13 10:41:49 UTC 2016
New revision: 413189
URL: https://svnweb.freebsd.org/changeset/ports/413189

Log:
  devel/*gcc*: convert to CONFIGURE_OUTSOURCE in trivial cases

  PR:		208294
  Exp-run by:	antoine
  Approved by:	portmgr blanket
  Differential Revision:	https://reviews.freebsd.org/D4157

Changes:
  head/devel/arm-none-eabi-gcc492/Makefile
  head/devel/djgpp-binutils/Makefile
  head/devel/powerpc64-gcc/Makefile
  head/devel/psptoolchain-gcc-stage1/Makefile
Comment 13 commit-hook freebsd_committer 2016-04-13 10:43:29 UTC
A commit references this bug:

Author: jbeich
Date: Wed Apr 13 10:42:37 UTC 2016
New revision: 413190
URL: https://svnweb.freebsd.org/changeset/ports/413190

Log:
  audio/oss: convert to CONFIGURE_OUTSOURCE

  PR:		208294
  Exp-run by:	antoine
  Differential Revision:	https://reviews.freebsd.org/D4157

Changes:
  head/audio/oss/Makefile
Comment 14 commit-hook freebsd_committer 2016-04-13 10:43:31 UTC
A commit references this bug:

Author: jbeich
Date: Wed Apr 13 10:43:22 UTC 2016
New revision: 413191
URL: https://svnweb.freebsd.org/changeset/ports/413191

Log:
  devel/fb-adb: convert to CONFIGURE_OUTSOURCE

  PR:		208294
  Exp-run by:	antoine
  Differential Revision:	https://reviews.freebsd.org/D4157

Changes:
  head/devel/fb-adb/Makefile